//---------------------------------------------------------------------------

#ifndef FormLogH
#define FormLogH
//---------------------------------------------------------------------------

#include "Mutex.h"
#include <Classes.hpp>
#include <ComCtrls.hpp>
#include <Controls.hpp>
#include <ExtCtrls.hpp>
#include <StdCtrls.hpp>
#include <deque>
#include <string>

#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>

//---------------------------------------------------------------------------
class TfrmLog : public TForm
{
__published:	// IDE-managed Components
	TTimer *tmrUpdate;
	TListView *ListView;
    TPanel *pnlBottom;
    TButton *btnClear;
	void __fastcall tmrUpdateTimer(TObject *Sender);
	void __fastcall ListViewData(TObject *Sender, TListItem *Item);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall btnClearClick(TObject *Sender);
private:	// User declarations
	Mutex mutex;
	std::deque<std::string> que;
	typedef void (__closure *CallbackClose)(void);
	bool bUpdated;
	unsigned int iBufSize;
public:		// User declarations
	__fastcall TfrmLog(TComponent* Owner);
	void OnLog(char *buf);
	void SetBufferSize(int size);
	CallbackClose callbackClose;
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmLog *frmLog;
//---------------------------------------------------------------------------
#endif
